// TeZ - SoS workshop  2018 - pulse sensor module + esp 32 //

#include <Metro.h>
#include "config.h"

//  #include <ESP8266WiFi.h>
  #include <WiFi.h>
  #include <WiFiUdp.h>
  #include <OSCMessage.h>


#include <Plaquette.h>
#include <PqExtra.h>

#include "wifisettings.h"

Metro alive = Metro(ALIVE_ACK_MS);

 #define INPUT_PIN 36 // VP pin on WROOM32 // analog in OK
// #define INPUT_PIN 39 // VN pin on WROOM32 // analog in OK
// #define INPUT_PIN 34 // analog in OK
// #define INPUT_PIN 35 // analog in OK
// #define INPUT_PIN 32 // analog in OK
// #define INPUT_PIN 33 // analog in OK

#define STDDEV_THRESHOLD 0.9 //.0
#define BUILTIN_LED 2 // built-in LED in WROOM32 is on pin 2

// Sensor input.
AnalogIn in(INPUT_PIN);

// Normalizer to N(0, 1).
AdaptiveNormalizer normalizer(0, 1);
//Normalizer normalizer(0, 1);

// Detects rising signals.
Thresholder peakDetector(STDDEV_THRESHOLD, THRESHOLD_HIGH);
//Thresholder peakDetector(STDDEV_THRESHOLD, THRESHOLD_RISING, 0.0f);
//DigitalOut led(LED_PIN); // LED output.

bool beatDispatched = false;
float lastreading, thisreading;
float IBI = 0;
unsigned long lastbeat = 0;
unsigned long now = 0;
int sensor_id = -1;

////////////////////////////////////////
void setup() {

  pinMode(INPUT_PIN, INPUT);
  pinMode(BUILTIN_LED, OUTPUT);

  Serial.begin(115200);

  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  
  WiFi.begin(ssid, pass);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    Serial.println("Connecting to WiFi..");
  }

  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  thisip = WiFi.localIP();
  Serial.println( thisip );

  // sensor ID is the last byte in the IP quad
  // sensor_id = thisip[3];
  sensor_id = WID; // fixed ID


}

////////////////////////////////////////
void dispatch_beat() {
  
    OSCMessage out("/sos/beat");
    out.add(sensor_id);
    out.add(IBI);
    
    Udp.beginPacket(dest, txport);
    out.send(Udp);
    Udp.endPacket();

    //Serial.println("beat");
    beatDispatched = true;
}

////////////////////////////////////////
void state_loop() {

  // send alive ACK message to show-control
  if(alive.check()) {
    _LOG("-> ACK");
    OSCMessage out("/oximeter/ack");
    out.add( sensor_id );
    Udp.beginPacket(dest, txport);
    out.send(Udp);
    Udp.endPacket();
    out.empty();
  }

}

////////////////////////////////////////
  void loop() {
  // process input.
  in >> normalizer;
  normalizer >> peakDetector; // >> led;
  thisreading = normalizer;

  Serial.print(thisreading);
  Serial.print(",");
  Serial.print(STDDEV_THRESHOLD);
  Serial.print(",");
 
  if (peakDetector) {
    now = millis();
    IBI = abs(now - lastbeat); //2 + (abs(now - lastbeat) / 1000); // IBI in seconds
    lastbeat = now;
    Serial.print(3.0);
    digitalWrite(BUILTIN_LED, HIGH);

    // send the beat osc message only once
    if(!beatDispatched) {
      dispatch_beat();
    }

  } else {
    Serial.print(.0);
    digitalWrite(BUILTIN_LED, LOW);
    // make sure we dispatch the next beat
    beatDispatched = false;
  }

  state_loop();

  Serial.println();
  delay(20);
}

